clear all
close all
clc
flowWords = [];             	%where the Hog Hof words with their centres are present
flowCentre = 20;				%Number of centers in k means clustering

%Format of words_VIBE.txt is [(y , x , t, opticalFlowBin, Size, opticalFlowValue)]
cumulativeWords = uint32(dlmread('words_VIBE.tsv','\t'));         %all words.we replace optical flow with the centre obtained from HoG HoF

for i=1:8
	%Format of traffic-junction-externalstip' num2str(i) '.csv' is [(x, y, t, centerID)], where t is for each indiviual video clip.
	temp = csvread(['./kmeansplusplus_code/centers_assigned/traffic-junction-externalstip' num2str(i) '.csv']);
	if i>1
		temp(:,3) = temp(:,3)+8900*(i-1);
	end
    flowWords = [flowWords;temp];
end
display('Files loaded and formatted ... ');
% Now we have each word of the form [x-coord y-coord frame flowCentre], where frame number is for globally combined 45 min clip.
% We know that in each 20x20 cell, we considered only point in foreground for kmeans center assignment of Hog-Hof.

%There is a one-one correspondence between cumulativeWords and flowWords.We
%do not need a dictionary for the map

for i=1:min(size(flowWords,1),size(cumulativeWords,1))
    y = uint32(cumulativeWords(i,1)); 
    x = uint32(cumulativeWords(i,2)); 
    t = uint32(cumulativeWords(i,3));
    cumulativeWords(i,4) = flowWords(i,4);
    if mod(i,10000)==0
        display(i);
    end
end

%wordCount = containers.Map;         % dictionary in matlab
% for i=1:size(flowWords,1)
%     
% 	% This is yet to be corrected by Abhijit inaccordance to the new 20x20 corrected code for filterForegroundSTIPparts.m
% 	x = uint32((flowWords(i,1))/20)*20;
%     y = uint32((flowWords(i,2))/20)*20;
% 	%x = uint32((flowWords(i,1)-1)/21)*21;
%     %y = uint32((flowWords(i,2)-1)/21)*21;
%     
% 	
% 	t = flowWords(i,3);
%     center = flowWords(i,4);
%     key  = [num2str(y) '_' num2str(x) '_' num2str(t)];
%     if (isKey(wordCount,key)==1)
%         mat = wordCount(key);
%         mat(center) = mat(center)+1;
%         wordCount(key) = mat;
%     else
%         mat = zeros(flowCentre,1);
%         mat(center) = mat(center) + 1;
%         wordCount(key) = mat;
%     end
% end
% clear flowWords
% display('wordCount dictionary created ... ');
% finalWords=[];
% for loop=1:size(cumulativeWords,1)
%     i = uint32(cumulativeWords(loop,1)); %y
%     j = uint32(cumulativeWords(loop,2)); %x
%     t = uint32(cumulativeWords(loop,3)); %t
%     key  = [num2str(i) '_' num2str(j) '_' num2str(t)];
%     if (isKey(wordCount,key)==0)
%    %     display('Some Error : no foreground point is considered for HOG-HOF in this cell'); %we'll have to ignore all such points
%     %    [i j t]
% 	xyz=5;
%     else
%         mat = wordCount(key);
%         [~,cumulativeWords(loop,4)] = max(mat);			%overwrite optialFlowBin
%         finalWords=[finalWords;cumulativeWords(:,1:5)];
%     end
% end
cumulativeWords = cumulativeWords(1:min(size(flowWords,1),size(cumulativeWords,1)),1:5);	%Remove opticalFlowValue and words for which hog hof centre have not been obtained
% 
% %Final Format of words_HOGHOF: [(y , x , t, kmeansCenterID, Size)]
save('words_HOGHOF.mat','cumulativeWords');    
display('Output saved. Done.');