%Authors - 
%Deepak Pathak 10222 deepakp@
%Abhijit Sharang 10007 abhisg@

%clear memory
clear all
clc

%Raw data file containing words
%data = dlmread('words_20box.tsv','\t');
load words_HOGHOF.mat
data = cumulativeWords;
clear cumulativeWords
[m,n] = size(data);

doc_length = 4;         %seconds
documents = floor((44*60+12)/doc_length);        %265
flowCentres = 20;   %the number of bins into which HOG HOF have been clustered
%Term frequency matrix : vocab * documents - 
%rows - documents : 5 sec each (last extra 2 sec ignored). 25 frames per sec.
%Fornula = frame/(25*doc_length) + 1
%words (i,j,frame,opticalFlow,size): Enumeration as follows
%Each location -> (0,0),(0,1),(1,0),(1,1) ... (4,0),(4,1)
%Image is h=288xw=360:14x18. For each value of i: 18**flowCentres*2 values ; for each i,j: flowCentres*2 values ; for each i,j,hoghof: 2 values.
%Formula = ((i/windowSize)*18+(j/windowSize))*(flowCentres*2)  + opticalFlow*2 + size + 1
windowSize = 20;
words = (280/windowSize+1)*(360/windowSize)*flowCentres*2;
FramesForWords = cell(words,documents);
for i=1:words
	for j=1:documents
		FramesForWords{i}{j} = [];
	end
end
 tfMatrix = zeros(words,documents);
 for row=1:size(data,1)
     i = data(row,1);
     j = data(row,2);
     frame = data(row,3);
     hoghof = data(row,4);
     blobSize = data(row,5);
     documentNumber = uint16(floor(frame/(25*doc_length)))+1;
     wordNumber = ((i/windowSize)*18+(j/windowSize))*flowCentres*2  + hoghof*2 + blobSize + 1;
     tfMatrix(wordNumber,documentNumber) = tfMatrix(wordNumber,documentNumber) + 1;
	 FramesForWords{wordNumber}{documentNumber} = [FramesForWords{wordNumber}{documentNumber};frame];
     if documentNumber == documents                    %(frame >= (44*60*25 + 25*10))
         break
     end
 end
 v = sum(tfMatrix);
 idx = find(v==0);
 tfMatrix(:,idx) = repmat(1e-07,words,numel(idx));
 save ('tfMatrix.mat','tfMatrix');

%free memory
clear data
anomaly = csvread('anomaly.csv');
load('tfMatrix.mat');

traindoc=[];
testdoc=[];
anomalous=[];
ct=0;
doc_indices=[];
for i=1:documents
    isAnomaly = 0;
    for j=1:size(anomaly,1)
        if floor(anomaly(j,1)/doc_length)+1<=i && floor(anomaly(j,2)/doc_length)+1>=i
            isAnomaly = 1;
            break;
        end
    end
    if isAnomaly==1
        testdoc=[testdoc;i];
        anomalous=[anomalous;i];
    else
        doc_indices=[doc_indices;i];
    end
end
ix = randperm(size(doc_indices,1));
doc_indices=doc_indices(ix);
lastind = floor(0.75*(documents-size(testdoc,1)));
for i=1:documents-size(testdoc,1)
    if i<=lastind
        traindoc=[traindoc;doc_indices(i)];
    else
        testdoc=[testdoc;doc_indices(i)];
    end
end
%test-train partition
trainData = tfMatrix(:,traindoc);
testData = tfMatrix(:,testdoc);
[size(traindoc) size(testdoc)]
%LEARNING SETTINGs
%How many topics in pLSA model
Learn.Num_Topics = 20;
%Max number of EM iterations
Learn.Max_Iterations = 500;
%Min. allowable lh change before EM termination
Learn.Min_Likelihood_Change   = 15;     
%Control level of printed and plotted output during learning   
Learn.Verbosity = 0;

%plsa train: all actual EM routine....
Li_testdocs={};
[Pw_z,Pd_z,Pz,Li,DocLi_train] = pLSA_EM_Train(trainData,[],Learn.Num_Topics,Learn);
Learn.Min_Likelihood_Change   = 1;
[Pw_z_test,Pd_z_test,Pz_test,Li_test,NormalizedDocLi_test]=  pLSA_EM_Test(testData,Pw_z,Learn.Num_Topics,Learn);

%Save current workspace
save(['workspace_' num2str(Learn.Num_Topics) 'topics_' num2str(doc_length) 'sDocLength_20box_' num2str(flowCentres) 'centers_HOGHOF.mat'])

