 // g++ backgroundSubtraction.cpp `pkg-config --cflags --libs opencv`

#include<opencv2/opencv.hpp>
#include<opencv2/video/tracking.hpp>
#include<iostream>
#include<fstream>
#include<highgui.h>
#include "package_bgs/FrameDifferenceBGS.cpp"
#include<vector>
#include<cstdio>
#include<numeric>
#include<map>
#define window 20

using namespace std;
using namespace cv;
int compare(const void *a,const void *b)
{
	if(*(double *)a-*(double *)b == 0)
		return 0;
	else if(*(double *)a-*(double *)b < 0)
		return -1;
	else return 1;
}

vector<float> word(cv::Mat xy,cv::Mat flow,cv::Mat foreground,vector<vector<Point> > contours,Mat filledContour,map<int,int> colMap,int i,int j,double thres_foreground,double thres_blob)
{
	int words[5];
	int blob[2];
	for(int k=0;k<5;k++)
		words[k]=0;
	for(int k=0;k<2;k++)
		blob[k]=0;
	float avgflow = 0;
	int totalpixels = 0;
	//cout<<foreground<<"\n";
	for(int k=i;k<foreground.rows && k<=i+window-1;k++)
	{
		for(int l=j;l<foreground.cols && l<=j+window-1;l++)
		{
			if((int)foreground.ptr<uchar>(k)[l] != 0)
			{
				int col = filledContour.ptr<uchar>(k)[l];
				if(contourArea(contours[colMap[col]]) < thres_blob)
					blob[0]++;
				else
					blob[1]++;
				avgflow += flow.ptr<float>(k)[l];
				totalpixels++;	
				if(flow.ptr<float>(k)[l]<thres_foreground)
					words[0]++;
				else
				{
					if(xy.ptr<float>(k)[l]>=0 && xy.ptr<float>(k)[l]<90)
						words[1]++;
					else if(xy.ptr<float>(k)[l]>=90 && xy.ptr<float>(k)[l]<180)
						words[2]++;
					else if(xy.ptr<float>(k)[l]>=180 && xy.ptr<float>(k)[l]<270)
						words[3]++;
					else	
						words[4]++;
				}

			}
		}
	}
	int max = -1,retval = -1;
	for(int k = 0;k<5;k++)
	{
		if(words[k]!=0 && words[k]>max)
		{
			max=words[k];
			retval = k;
		}
	}
	vector<float> w;
	w.push_back(retval);
	if(blob[0]>blob[1])
		w.push_back(0);
	else
		w.push_back(1);
	if(totalpixels!=0)
		w.push_back(avgflow*1.0/totalpixels);
	else
		w.push_back(0);
	return w;
}

int main(int argc, char *argv[])
{
	cv::Mat frame1;
	cv::Mat frame2;
	cv::Mat flow;
	cv::Mat foreground;
	cv::Mat background;
	cv::VideoCapture cap("../../traffic-junction.avi");
	cap>>frame1;
	if(frame1.channels()>=3)
		cv::cvtColor(frame1,frame1,CV_BGR2GRAY);
	int counter=2;
	while(true)
	{
		if(!(cap.grab() && cap.retrieve(frame2)))
			break;
		if(frame2.channels()>=3)
			cv::cvtColor(frame2,frame2,CV_BGR2GRAY);

		vector<vector<Point> > contours;
		vector<Vec4i> hierarchy;

		char imageName[200];
		sprintf(imageName,"../../outmorpho/frame%d.jpg",counter);
		int ct = 0;
		foreground = cv::imread(imageName);
		cvtColor(foreground,foreground,CV_BGR2GRAY);
		if(counter>=1)
		{
			cv::Mat filledContour = cv::Mat::zeros(foreground.rows,foreground.cols,CV_8U);		
			cv:: Mat fore_clone;
			imwrite("temp.png",foreground);
			fore_clone=imread("temp.png");
			cvtColor(fore_clone,fore_clone,CV_BGR2GRAY);
			cv::findContours(fore_clone,contours,hierarchy,CV_RETR_CCOMP,CV_CHAIN_APPROX_SIMPLE);
			if(hierarchy.size()!=0)
			{
				int idx = 0;
				map<int,int> colMap;
				int r = 1;			
				for( ; idx >= 0; idx = hierarchy[idx][0] )
				{
					cv::Scalar color( r);
					colMap[r++] = idx;
					drawContours(filledContour, contours, idx, color, CV_FILLED, 8, hierarchy );
				}
				cv::calcOpticalFlowFarneback(frame1,frame2,flow,0.5,1,3,1,5,1.1,1);
				cv::Mat xy[2];
				split(flow,xy);
				//calculate angle and magnitude
				cv::Mat magnitude, angle;
				cv::cartToPolar(xy[0], xy[1], magnitude, angle, true);
				for(int i = 0;i<foreground.rows;i+=window)
				{
					for(int j = 0;j<foreground.cols;j+=window)
					{
						vector<float> w = word(angle,magnitude,foreground,contours,filledContour,colMap,i,j,0,800);
						if(w[0]!=-1)
							cout<<i<<"\t"<<j<<"\t"<<counter<<"\t"<<(int)w[0]<<"\t"<<(int)w[1]<<"\t"<<w[2]<<"\n";
					}
				}

			}
		}
		counter++;
	}
	return 0;
}
