%Improved foreground extraction by ViBE because if car becomes stationary (as in frame difference) then we are loosing in terms of words.
%ViBE binary file runs only for 10K frames, so we run it from 1-9900, then 8901-1790 ... i.e. 1000 frame overlap.

clear all
close all
clc
vid = VideoReader('D:/BTPDataset/traffic-junction.avi');
numOfFrames = vid.NumberOfFrames;    %66324 Frames

startFrame = 1;
clipCount = 1;
frameCount = 1;
while(1)
    if(numOfFrames - startFrame < 9899)
        endFrame = numOfFrames;
    else
        endFrame = startFrame + 9899; %1:9900
    end
    
    outputVideo = VideoWriter(['D:\BTPDataset\outputTempVideo' num2str(clipCount) '.avi']);
    outputVideo.FrameRate = vid.FrameRate;
    open(outputVideo);
    imgMatrix = [];
    for frame=startFrame:endFrame
        img = read(vid,frame);
        writeVideo(outputVideo,img);
    end
    close(outputVideo);
    status = dos(['D:\BTPDataset\vibe\vibe-rgb.exe -i D:\BTPDataset\outputTempVideo' num2str(clipCount) '.avi -ro -o D:\BTPDataset\output\vibeOutput' num2str(clipCount) '\result-%010d.jpg']);
    if(status==0)
        display(['Clipcount numer ' num2str(clipCount) ' finished succesfully']);
    else
        display(['Clipcount numer ' num2str(clipCount) ' : SOME ERROR OCCURED']);
    end
    
    files = dir(['../../../BTPDataset/output/vibeOutput' num2str(clipCount) '/*.jpg']);
    for i = 1:size(files,1)
        if(clipCount>1 && i<=1000)
            continue;
        end
        img = im2bw(rgb2gray(imread(['../../../BTPDataset/output/vibeOutput' num2str(clipCount) '/' files(i).name])));
        img = imerode(img,strel('square',3));
        img = imdilate(img,strel('square',9));
        img = imerode(img,strel('square',3));
        imwrite(img,['../../../BTPDataset/outputMorphology/frame' num2str(frameCount) '.jpg']);
        frameCount=frameCount+1;
    end
    
    if frameCount > numOfFrames
        break;
    end
    
    clipCount=clipCount+1;
    startFrame = startFrame + 8900;
end